=== Components/Metrics/CorrespondingPointsEuclideanDistanceMetric/CMakeLists.txt ===

ADD_ELXCOMPONENT( CorrespondingPointsEuclideanDistanceMetric
 elxCorrespondingPointsEuclideanDistanceMetric.cxx
 elxCorrespondingPointsEuclideanDistanceMetric.h
 elxCorrespondingPointsEuclideanDistanceMetric.hxx
 itkCorrespondingPointsEuclideanDistancePointMetric.h
 itkCorrespondingPointsEuclideanDistancePointMetric.hxx )
