=== Components/Metrics/DistancePreservingRigidityPenalty/CMakeLists.txt ===

ADD_ELXCOMPONENT( DistancePreservingRigidityPenalty
 elxDistancePreservingRigidityPenaltyTerm.h
 elxDistancePreservingRigidityPenaltyTerm.hxx
 elxDistancePreservingRigidityPenaltyTerm.cxx
 itkDistancePreservingRigidityPenaltyTerm.h
 itkDistancePreservingRigidityPenaltyTerm.hxx )
