=== Components/Metrics/NormalizedMutualInformation/CMakeLists.txt ===

ADD_ELXCOMPONENT( NormalizedMutualInformationMetric
 elxNormalizedMutualInformationMetric.h
 elxNormalizedMutualInformationMetric.hxx
 elxNormalizedMutualInformationMetric.cxx
 itkParzenWindowNormalizedMutualInformationImageToImageMetric.h
 itkParzenWindowNormalizedMutualInformationImageToImageMetric.hxx )
