=== debian/changelog ===
elastix (4.9.0-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * [b3360a0] d/u/metadata: yamllint

 -- Steve M. Robbins <smr@debian.org>  Fri, 14 Aug 2020 21:36:15 -0500

elastix (4.9.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Fix watch file
  * debhelper 12
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Suppress dh_dwz due to: 'dwz: Too few files for multifile optimization'
  * Fix EPOCH_DATE
  * Set "Rules-Requires-Root: no" to avoid issues with fakeroot
  * Fix generation of docs using doxygen and move all code under one target
  * Install Apache NOTICE file
  * Remove unused lintian-override

  [ Jelmer Vernooĳ ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.

 -- Andreas Tille <tille@debian.org>  Tue, 15 Jan 2019 11:24:43 +0100
