=== debian/control ===
Source: elastix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Gert Wollny <gewo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               libinsighttoolkit4-dev,
               libdcmtk-dev,
               zlib1g-dev,
               libpng-dev,
               libtiff-dev,
	       libnifti-dev,
               libfftw3-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     texlive-publishers,
                     ghostscript
Standards-Version: 4.3.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/elastix
Vcs-Git: https://salsa.debian.org/med-team/elastix.git
Homepage: http://elastix.isi.uu.nl/

Package: elastix
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
 .
 This package contains the elastix documentation.
