=== debian/watch ===
version=4

https://github.com/SuperElastix/elastix/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@
